Summary:	Parallel graph partitioning
Name:		parmetis
Version:	3.1.1
Release:	2
License:	GPL
Group:		Applications/Library
Source0:	http://www-users.cs.umn.edu/~karypis/metis/parmetis/files/ParMetis-%{version}.tar.bz2
Source1:	metis.pdf
Patch:		notest.patch
Patch1:		shared.patch
URL:		http://www-users.cs.umn.edu/~karypis/metis/parmetis/index.html
BuildRoot:	/var/tmp/%{name}-%{version}-root-%(id -u -n)
BuildArch:	i386 x86_64
BuildRequires:	gcc gzip bzip2
#Conflicts:	metis
Obsoletes:	metis
Provides:	metis
Prefix:		/usr

%description
ParMetis is the parallel version of METIS, a set of programs for partitioning
graphs, partitioning finite element meshes, and for producing fill reducing
orderings for sparse matrices.

%prep
%setup -q -n ParMetis-%version
%patch -p1
%patch1 -p1

%build
make
cp Manual/manual.pdf Manual/parmetis.pdf
cp $RPM_SOURCE_DIR/metis.pdf Manual/metis.pdf

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT{%{_libdir},%{_includedir}/{metis,parmetis},%{_docdir}/parmetis}
/bin/cp -pf libmetis.so libparmetis.so $RPM_BUILD_ROOT%{_libdir}
/bin/cp -pf METISLib/{defs.h,macros.h,rename.h,struct.h,stdheaders.h} \
	$RPM_BUILD_ROOT%{_includedir}/metis/.

# C++ compatibility stuffs
echo "#ifdef __cplusplus"  >$RPM_BUILD_ROOT%{_includedir}/metis/proto.h
echo "extern \"C\" {"	  >>$RPM_BUILD_ROOT%{_includedir}/metis/proto.h
echo "#endif"		  >>$RPM_BUILD_ROOT%{_includedir}/metis/proto.h
echo ""			  >>$RPM_BUILD_ROOT%{_includedir}/metis/proto.h
# the declaration "int log2(int);" in proto.h conflicts with the standard
# math function "log2".
/bin/grep -v 'int log2(int)' METISLib/proto.h \
			  >>$RPM_BUILD_ROOT%{_includedir}/metis/proto.h
echo ""			  >>$RPM_BUILD_ROOT%{_includedir}/metis/proto.h
echo "#ifdef __cplusplus" >>$RPM_BUILD_ROOT%{_includedir}/metis/proto.h
echo "}"		  >>$RPM_BUILD_ROOT%{_includedir}/metis/proto.h
echo "#endif"		  >>$RPM_BUILD_ROOT%{_includedir}/metis/proto.h

sed -e 's/<\(defs\|struct\|macros\|rename\|proto\|stdheaders\)\.h>/<metis\/\1.h>/g' METISLib/metis.h -e 's/\.\.\/parmetis\.h/parmetis.h/g' \
	> $RPM_BUILD_ROOT%{_includedir}/metis.h
/bin/cp -pf parmetis.h $RPM_BUILD_ROOT%{_includedir}/parmetis.h

/bin/chmod -R a+rX $RPM_BUILD_ROOT/.

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%files
%doc CHANGES INSTALL Manual/parmetis.pdf Manual/metis.pdf
/usr/include/*.h
/usr/include/*/*.h
/usr/lib/lib*.so

%changelog
